﻿XIncludeFile "PortAudio.pb"

Enumeration
  #WIN_MAIN
  #TrackBar_Duration
  #TrackBar_FrqFrom
  #Button_0
  #CheckBox_Filter
  #CheckBox_Metallic
  #CheckBox_Chorus
  #CheckBox_Wobble
  #Frame3D_0
  #TrackBar_Chorus
  #TrackBar_Wobble
  #TrackBar_FrqTo
  #TrackBar_NumSgmt
  #TrackBar_MinSgmt
  #Text_0
  #Text_1
  #Text_2
  #TrackBar_Envelope
  #Frame3D_1
  #Text_4
  #Text_5
  #Text_7
  #CheckBox_Repeat
  #Progresser
  #Text_Criteria
  #IMAGE_FILE
  #IMAGE_DISPLAY
  #IMAGE_MEMORY
  #ButtonIm
EndEnumeration

Declare Chorus16(CDelay.d, CDepth.d, CFreq.d, CGain.d)
Declare.d Interpolate(ValStr.s) 
Declare FillTheVoice(VocSnippetLength.l)
Declare.i Rand(Low.i, High.i)
Declare.d Saw(Phh.d)
Declare Wobbler()
Declare CrazyDelay()
Declare ApplyCrazyFilter()
Declare.l MaxValOfVoc(Array TheArray.l(1))
Declare NormalizeVoc()
Declare VoiceSequencer()
Declare CocktailSort1(Array pvarArray.i(1))
Declare FillTheVoice(VocSnippetLength.l)
Declare.d MoogFilter16(Uo.d)
Declare SelectUtterance(VocSnipLen.l)
Declare Windower()
Declare WriteDoubleArrayToFile(Array DArr.d(1), Filename$)
Declare ReadDoubleArrayFromFile(Array DArr.d(1), Filename$) 
Declare OpenTheFile()
Declare SaveTheFile()
Declare ShowAboutWindow()
Declare.s GetExePath()

Global TheArrLen.l ;this is for passing length of segments arr to cocktailsort
Global Dim FinalGranularArr.d(0) ;this is the arr of the complete sound
Global Dim QArr.d(0) ;this is the arr of the sound of each segment
Global QArrSize.l ;the number of samples in QArr

Global Pi2.d = 6.28318530717958
Global Pi.d = 3.14159265358979
Global SampleRate.d = 44100
Global LevelFrom.l ;value of from frq slider
Global LevelTo.l ;value of to frq slider
Global GarbleDuration.i ;in seconds, total duration of garble
Global GarbleSamples.i ;garble duration converted to number of samples in garble duration
Global mu.d ;for translation from garbleduration To samples
Global so.i ;for translation from garbleduration To samples

Global EnvelopeVal ;value of the envelope slider
Global DoChorus.i ;for whether we do chorus or not
Global ChorusVal.i ;value of the chorus slider
Global DoFilter.i ;for whether we do the bp, lp filter or not
Global DoWobble.i ;for whether we do tremolo or not
Global WobbleVal.i ;value of the tremolo slider
Global DoCrazyDelay.i ;for whether we do crazy delay or not
Global NumSgmtsVal.i ;value of the num segments slider
Global MinSegVal.i ;value of minimum segment length slider

;Global FromFrqVal.i ;value of from frequency slider
;Global ToFrqVal.i ;value of to frequency slider
Global DoRepeat.i ;for whether we repeat the sound we have just synthesized or not
Global PlayedAtLeastOnce.i ; for whether the Repeat checkbox is allowed to be ticked or not

Global Fase.d
Global Fase_Add.d

;this is for the callback function:

Global n.i
n = 0

Global cutoffo.d
Global t1o.d
Global t2o.d
Global reso.d
Global Fo.d
Global Ko.d
Global Po.d
Global ro.d
Global Xo.d
Global Y1o.d
Global y2o.d
Global y3o.d
Global y4o.d
Global oldxo.d
Global oldy1o.d
Global oldy2o.d
Global oldy3o.d

Global InitF1.d
Global InitF2.d
Global InitF3.d
Global InitB1.d
Global InitB2.d
Global InitB3.d
Global F1Increment.d
Global F2Increment.d
Global F3Increment.d
Global BW1Increment.d
Global BW2Increment.d
Global BW3Increment.d
Global AmplitudeResonator1.l
Global AmplitudeResonator2.l
Global AmplitudeResonator3.l

Global TransitionPoint.l
Global SelectTheVoice.l

LevelFrom = 60
LevelTo = 450

EnvelopeVal = 35

NumSgmtsVal = 20

MinSegVal = 40

ChorusVal = 25
GarbleDuration = 2000
mu = (GarbleDuration/1000)*samplerate
so = Int(mu)
GarbleSamples = so

WobbleVal = 23

dochorus = 0

dofilter = 0

dowobble = 0

docrazydelay = 0

dorepeat = 0
PlayedAtLeastOnce = 0

Global WasAFileOpened.s

Global Quit.b = #False
#FLAGS = #PB_Window_SystemMenu | #PB_Window_ScreenCentered
If OpenWindow(#WIN_MAIN, 504, 312, 541, 245, "Garble Marvel", #FLAGS)
  
  If CreateMenu(0, WindowID(#WIN_MAIN))    ; menu creation starts....
      MenuTitle("File")
        MenuItem(1, "Open"   +Chr(9)+"Ctrl+O")
        MenuItem(2, "Save"   +Chr(9)+"Ctrl+S")
      MenuTitle("?")
      MenuItem(3, "About")
      MenuItem(4, "Help")
  
    EndIf
  
    If CreateGadgetList(WindowID(#WIN_MAIN))
      
      If CatchImage(#IMAGE_MEMORY, ?Image) ;Change the path to image...
      ResizeImage(#IMAGE_MEMORY, 100, 80)
      ButtonImageGadget(#ButtonIm, 400, 28, 110, 90, ImageID(#IMAGE_MEMORY))
      
      TrackBarGadget(#TrackBar_Duration, 40, 50, 20, 130, 200, 8000, #PB_TrackBar_Vertical)
      SetGadgetState(#TrackBar_Duration,2000)
      TrackBarGadget(#TrackBar_FrqFrom, 90, 50, 20, 130, 30, 750, #PB_TrackBar_Vertical)
      TrackBarGadget(#TrackBar_FrqTo, 140, 50, 20, 130, 30, 750, #PB_TrackBar_Vertical)
      SetGadgetState(#TrackBar_FrqTo,450)
      CheckBoxGadget(#CheckBox_Filter, 330, 50, 60, 20, "Filter")
      CheckBoxGadget(#CheckBox_Metallic, 330, 80, 60, 20, "Metallic")
      CheckBoxGadget(#CheckBox_Chorus, 330, 110, 50, 20, "Chorus")
      CheckBoxGadget(#CheckBox_Wobble, 330, 140, 60, 20, "Wobble")
      CheckBoxGadget(#CheckBox_Repeat, 330, 200, 60, 20, "Repeat")
      Frame3DGadget(#Frame3D_0, 320, 10, 210, 180, "Effects On Segments")
      TrackBarGadget(#TrackBar_Chorus, 390, 120, 130, 20, 10, 90)
      SetGadgetState(#TrackBar_Chorus,25)
      TrackBarGadget(#TrackBar_Wobble, 390, 150, 130, 20, 10, 80)
      SetGadgetState(#TrackBar_Wobble,23)
      TrackBarGadget(#TrackBar_NumSgmt, 190, 50, 20, 130, 0, 100, #PB_TrackBar_Vertical)
      SetGadgetState(#TrackBar_NumSgmt,20)
      TrackBarGadget(#TrackBar_MinSgmt, 240, 50, 20, 130, 14, 65, #PB_TrackBar_Vertical)
      SetGadgetState(#TrackBar_MinSgmt,40)
      TextGadget(#Text_0, 20, 30, 50, 20, "Duration")
      TextGadget(#Text_1, 70, 30, 50, 20, "Frq From")
      TextGadget(#Text_2, 130, 30, 40, 20, "Frq To")
      TrackBarGadget(#TrackBar_Envelope, 290, 50, 20, 130, 3, 65, #PB_TrackBar_Vertical)
      SetGadgetState(#TrackBar_Envelope,35)
      Frame3DGadget(#Frame3D_1, 10, 10, 300, 180, "Garble Sequence")
      TextGadget(#Text_4, 170, 20, 50, 30, "Num Of Sgmts")
      TextGadget(#Text_5, 220, 20, 50, 30, "Min Sgmt Length")
      TextGadget(#Text_7, 280, 30, 20, 20, "Env")
      ProgressBarGadget(#Progresser,  10, 200, 150,  10, 0, 20000)
      TextGadget(#Text_Criteria, 170, 200, 100, 20,"")
Repeat
Event.l = WaitWindowEvent()
Select Event
Case #PB_Event_Gadget
  Select EventGadget()
    Case #TrackBar_FrqTo
      Levelto = GetGadgetState(#TrackBar_Frqto)
      If GetGadgetState(#TrackBar_FrqTo)<levelfrom
        SetGadgetState(#TrackBar_FrqTo, levelfrom)
      EndIf 
    Case #TrackBar_FrqFrom
      LevelFrom = GetGadgetState(#TrackBar_FrqFrom)
      If GetGadgetState(#TrackBar_Frqfrom)>levelto
        SetGadgetState(#TrackBar_Frqfrom, levelto)
      EndIf 
    Case #TrackBar_Duration 
      If DoRepeat<>1
        GarbleDuration = GetGadgetState(#TrackBar_Duration)
        mu = SampleRate*(GarbleDuration/1000)
        so = Int(mu)
        GarbleSamples = so 
      EndIf  
     Case #ButtonIm
      If DoRepeat = 0
        Gosub PlayWave  
      Else
        Gosub RepeatPlay
      EndIf     
    Case #CheckBox_Chorus
      If GetGadgetState(#CheckBox_Chorus) = 1 
        dochorus = 1
      Else
        dochorus = 0
      EndIf
    Case #CheckBox_Metallic
      If GetGadgetState(#CheckBox_Metallic) = 1 
        docrazydelay = 1
      Else
        docrazydelay = 0
      EndIf
    Case #CheckBox_Filter
      If GetGadgetState(#CheckBox_Filter) = 1 
        dofilter = 1
      Else
        dofilter = 0
      EndIf
    Case #CheckBox_Wobble
      If GetGadgetState(#CheckBox_Wobble) = 1 
        DoWobble = 1
      Else
        DoWobble = 0
      EndIf
    Case #CheckBox_Repeat
      If PlayedAtLeastOnce = 0
        SetGadgetState(#CheckBox_Repeat, #PB_Checkbox_Unchecked)
        DoRepeat = 0
      Else  
          If GetGadgetState(#CheckBox_Repeat) = 1 
            DoRepeat = 1
          Else
            DoRepeat = 0
            GarbleDuration = GetGadgetState(#TrackBar_Duration)
            mu = SampleRate*(GarbleDuration/1000)
            so = Int(mu)
            GarbleSamples = so 
          EndIf
      EndIf    
    Case #TrackBar_Chorus
      ChorusVal = GetGadgetState(#TrackBar_Chorus)
    Case #TrackBar_Wobble
      WobbleVal = GetGadgetState(#TrackBar_Wobble)  
    Case #TrackBar_Envelope
      EnvelopeVal = GetGadgetState(#TrackBar_Envelope)
    Case #TrackBar_NumSgmt
      NumSgmtsVal = GetGadgetState(#TrackBar_NumSgmt)
    Case #TrackBar_MinSgmt
      MinSegVal = GetGadgetState(#TrackBar_MinSgmt)
  EndSelect
  
Case #PB_Event_Menu
    Select EventMenu()
      Case 1
        OpenTheFile()
        If WasAFileOpened<>""
          Gosub RepeatPlay
        EndIf  
     Case 2 : SaveTheFile()
     Case 3
       MessageRequester("About", "Garble Marvel v1.01 " + Chr(169) + " Jim Singh" + Chr(13) + "Dedicated to meeting your high" + Chr(13) + "quality garble generation needs")
     Case 4
       ShowAboutWindow()
   EndSelect
  
EndSelect
Until Event = #PB_Event_CloseWindow Or Quit = #True
EndIf
EndIf
EndIf
End

DataSection
  Image:
  IncludeBinary "garblemarvelfaceimage.bmp"
EndDataSection

Procedure SaveTheFile()
  StandardFile$ = GetExePath() + "GloriousGarble.gm"  ; set initial file+path to display
  Pattern$ = "GarbleMarvel (*.gm)|*.gm"
  Pattern = 0    ; use the first pattern
  File$ = SaveFileRequester("Please choose file to save", StandardFile$, Pattern$, Pattern)
  If File$
    If UCase(Right(File$, 3)) <> ".GM"
      File$ = File$ + ".gm"
    EndIf  
    WriteDoubleArrayToFile(FinalGranularArr(), File$)
  Else
    MessageRequester("Informer", "Your Garble Marvel sequence is not saved!", 0) 
  EndIf
EndProcedure

Procedure OpenTheFile()
  StandardFile$ = GetExePath()   ; set initial file+path to display
  Pattern$ = "GarbleMarvel (*.gm)|*.gm"
  Pattern = 0 
  File$ = OpenFileRequester("Please choose file to open", StandardFile$, Pattern$, Pattern)
  WasAFileOpened = File$
  If File$
    ReadDoubleArrayFromFile(FinalGranularArr(), File$)
    GarbleDuration = Int((GarbleSamples/SampleRate)*1000)
    SetGadgetState(#CheckBox_Repeat, #PB_Checkbox_Checked)
    DoRepeat = 1
  EndIf
EndProcedure

Procedure.s GetExePath()
  Protected Path.s = GetPathPart(ProgramFilename())
  If Path = GetTemporaryDirectory()
    Path = GetCurrentDirectory()
  EndIf
  ProcedureReturn Path
EndProcedure

PlayWave:

Procedure VoiceSequencer()
Dim TheSectionArr.i(0)
Define GoodArr.l ;want this to be boolean
Define Noo.l
Define Too.l
Define Xoo.l
Define Ioo.l
Define SecCount.l

ReDim FinalGranularArr(GarbleSamples)

GoodArr = 0

SecCount = Int((GarbleSamples / 1000 / 3) * (NumSgmtsVal / 100))

If SecCount = 0
SecCount = 1
EndIf

TheArrLen = SecCount

ReDim TheSectionArr(SecCount)
TheSectionArr(0) = 0

;initialize moog filter
Y1o = 0
y2o = 0
y3o = 0
y4o = 0
oldxo = 0
oldy1o = 0
oldy2o = 0
oldy3o = 0

Define LoopCounter.i
Define TooManyRepeats.i
Define TheCompareVal.i
Define DropTheDuration.i
Define FlashWarningOnce.i
loopcounter = 0
TooManyRepeats = 0
DropTheDuration = 0
FlashWarningOnce = 0
Define BlankProgressText.i
BlankProgressText = 0

Repeat
  loopcounter = loopcounter +1
  If LoopCounter<=20000
    SetGadgetAttribute(#Progresser, #PB_ProgressBar_Maximum, 20000) 
    SetGadgetState   (#Progresser, LoopCounter)
        If BlankProgressText = 0
          TextGadget(#Text_Criteria, 170, 200, 60, 20,"")
          BlankProgressText = 1
        EndIf  
  EndIf  

  If loopcounter>20000
    TooManyRepeats = 1
  EndIf  
  
  If TooManyRepeats = 1
    If FlashWarningOnce = 0
      TextGadget(#Text_Criteria, 170, 200, 100, 20,"Cannot Meet Criteria!")
      FlashWarningOnce = 1
    EndIf  
  EndIf
  
  If TooManyRepeats = 1
    DropTheDuration = DropTheDuration +1
  EndIf  
    
   For Noo = 1 To SecCount
   If Noo = SecCount
   TheSectionArr(Noo) = GarbleSamples
   Else
   TheSectionArr(Noo) = Rand(0, GarbleSamples)
   EndIf
 Next Noo
  
   CocktailSort1(TheSectionArr())
   For Noo = 1 To SecCount
     If TooManyRepeats = 1
       If DropTheDuration >= 3000 
         GarbleSamples = GarbleSamples * 0.95
         SetGadgetState(#TrackBar_Duration, Int((GarbleSamples/SampleRate)*1000))
         GarbleDuration = Int((GarbleSamples/SampleRate)*1000)
         ReDim FinalGranularArr(GarbleSamples)
         SecCount = Int((GarbleSamples / 1000 / 3) * (NumSgmtsVal / 100))
           If SecCount = 0
           SecCount = 1
           EndIf
         DropTheDuration = 0
       EndIf
     EndIf  
     If (TheSectionArr(Noo) - TheSectionArr(Noo - 1)) < Int((MinSegVal / 100) * (GarbleSamples / SecCount))
         GoodArr = 0
         Break
     Else
       GoodArr = 1
     EndIf
   Next Noo
 Until GoodArr = 1

Too = -1
Xoo = -1

For Too = 0 To SecCount - 1
   FillTheVoice(TheSectionArr(Too + 1) - TheSectionArr(Too))
       For Ioo = 0 To QArrSize
       Xoo = Xoo + 1
       If Xoo < GarbleSamples
           FinalGranularArr(Xoo) = QArr(Ioo)
       EndIf
       Next Ioo
Next Too
EndProcedure

VoiceSequencer()

Procedure.i Rand(Low.i, High.i)
  Define Q.i
  Q = Int((High - Low+1) * (Random(100)/100)) + Low
  If q>high
    q = high
    EndIf
  ProcedureReturn Q
EndProcedure

Procedure Error(err)
  MessageRequester("", PeekS(Pa_GetErrorText(err)))
  End
EndProcedure

Procedure.d Saw(Phh.d)
  Define Q.d 
  If Phh < 0.5
   Q = 0.35 * Sin(Phh)
  Else
   Q = (0.35 * Sin(1 - Phh)) + 0.5
  EndIf
ProcedureReturn Q
EndProcedure

Procedure Wobbler()
        Define Faze.d
        Define Faze_Add.d
        Define Koo.l
        Faze = 0
        Faze_Add = ((WobbleVal / 10)*(WobbleVal/10)) / SampleRate
        For koo = 0 To QArrSize
            QArr(koo) = QArr(koo) * (0.5 - 0.4 * Sin(Pi2 * Faze))
            Faze = Faze + Faze_Add
            If Faze > 1
              Faze = Faze - 1
            EndIf  
        Next koo
EndProcedure  


Procedure Chorus16(CDelay.d, CDepth.d, CFreq.d, CGain.d)

Define MaxD.l ;max delay in samples
Define MinD.l;min delay in samples
Define BaseDelay.d ;starting delay in samples
Define DepthFraction.d ;conversion of CDepth To a fraction
Define Io.l
Define Ao.l
Define Mo.d
Define Wo.d
Define StringToAnalyze.s
Dim ChorusAr.d(0)

Ao = 0

DepthFraction = CDepth / 100
MaxD = Round(((DepthFraction * CDelay) + CDelay) * (SampleRate / 1000), #PB_Round_Nearest)
MinD = Round(((CDelay) * (SampleRate / 1000)), #PB_Round_Nearest)
BaseDelay = 0.5 * (MinD + MaxD)

ReDim ChorusAr(QArrSize)

For Io = 0 To QArrSize
If Io < BaseDelay
    ChorusAr(Io) = QArr(Io) / 2
Else
    Ao = Ao + 1
    Wo = Sin(4 * ATan(1) * 2 * (CFreq / SampleRate) * (Ao - 1))
    Mo = 0.5 * ((MinD + MaxD) + (Wo * (MaxD - MinD)))
    StringToAnalyze = StrD((io-mo),8)
    DotPos.l = FindString(StringToAnalyze, ".", 1)
    StrLength.l = Len(StringToAnalyze)
    If Right(stringtoanalyze, strlength-dotpos) = "00000000"
      ChorusAr(Io) = (QArr(Io) + (CGain / 100) * QArr(Io - Int(Mo))) / 2
    Else
      ChorusAr(Io) = (QArr(Io) + (CGain / 100) * Interpolate(StrD(Io - Mo))) / 2
    EndIf 
EndIf
Next Io

For Io = 0 To QArrSize
QArr(Io) = ChorusAr(Io)
Next Io

EndProcedure

Procedure.d Interpolate(ValStr.s) 
Define IntPartStr.s
Define DecPartStr.s
Define IntPart.l
Define DecPart.d
Define NumAsString.s
Define DecPos.l
Define StrLength.l
Define InterpolateReturn.d
NumAsString = ValStr
DecPos = FindString(NumAsString, ".", 1)
IntPartStr = Left(NumAsString, (DecPos - 1))
StrLength = Len(NumAsString)
DecPartStr = "0." + Right(NumAsString, (StrLength - DecPos))
IntPart = Val(IntPartStr)
DecPart = ValD(DecPartStr)
If intpart < 0 
  IntPart = 0
EndIf 
InterpolateReturn = (QArr(IntPart) * (1 - DecPart)) + (QArr(IntPart + 1) * DecPart) 
ProcedureReturn InterpolateReturn
EndProcedure

Procedure CrazyDelay()

Dim F1.d(0)
Dim F2.d(0)
Dim F3.d(0)
Define a1.d
Define a2.d
Define b0.d
Define b1.d
Define b2.d
Define Delay1.l
Define Delay2.l
Define Nx.l

ReDim F1(QArrSize)
ReDim F2(QArrSize)
ReDim F3(QArrSize)

a1 = Rand(50, 99) / 100
a2 = Rand(50, 99) / 100
b0 = Rand(50, 99) / 100
b1 = Rand(50, 99) / 100
b2 = Rand(50, 150) / 100
Delay1 = Rand(100, 500)
Delay2 = Rand(400, 2500)

    For Nx = 0 To QArrSize
        If Nx >= Delay1
            F1(Nx) = QArr(Nx) + a1 * F1(Nx - Delay1)
        Else
            F1(Nx) = QArr(Nx)
        EndIf
        If N >= Delay2
            F2(Nx) = F1(Nx) + a2 * F2(Nx - Delay2)
        Else
            F2(Nx) = F1(Nx)
        EndIf
        F3(Nx) = (b0 * QArr(Nx) + b1 * F1(Nx) + b2 * F2(Nx)) / 3
    Next Nx


For Nx = 0 To QArrSize
QArr(Nx) = F2(Nx)
Next Nx

EndProcedure

Procedure ApplyCrazyFilter()

Define fz2.d
Define fb2.d
Define Buf02.d
Define Buf12.d
Define Hp2.d
Define Bp2.d
Define Lp2.d
Define Qz2.d
Define Freq2.i
Define InputVal2.d
Define Filter2MaxCutoff.i
Define SelectFilterType.i
Define Np.l

Filter2MaxCutoff = ((SampleRate * ASin(0.5)) / (4 * ATan(1))) - 1
Buf02 = 0
Buf12 = 0
Freq2 = Rand(80, Filter2MaxCutoff)
SelectFilterType = Rand(1, 2)

If SelectFilterType = 1
Freq2 = Rand(125, 350)
Else
Freq2 = Rand(100, Filter2MaxCutoff)
EndIf

Qz2 = Rand(1, 100) / 100
fz2 = 2 * Sin((4 * ATan(1)) * Freq2 / SampleRate)
fb2 = Qz2 + Qz2 / (1 - fz2)

For Np = 0 To QArrSize
    InputVal2 = QArr(Np)
    Hp2 = InputVal2 - Buf02
    Bp2 = Buf02 - Buf12
    Buf02 = Buf02 + fz2 * (Hp2 + fb2 * Bp2)
    Buf12 = Buf12 + fz2 * (Buf02 - Buf12)
    If SelectFilterType = 1
    QArr(Np) = Buf12
    ElseIf SelectFilterType = 2
    QArr(Np) = Bp2
    EndIf
Next Np

EndProcedure

Procedure.l MaxValOfVoc(Array TheArray.l(1)) 
Define I.l
Define MaxLngIndex.l
Define Phi.l
MaxLngIndex = 0

For I = 1 To QArrSize
    If TheArray(I) > TheArray(MaxLngIndex)
    MaxLngIndex = I
    EndIf
Next
Phi = TheArray(MaxLngIndex)
ProcedureReturn Phi
EndProcedure

Procedure NormalizeVoc()

Define MaxVal.l
Dim SizeArr.l(0)
Define ReFactor.d
ReDim SizeArr(QArrSize)
Define K.l
Define Sample.l

For K = 0 To QArrSize
Sample = Abs(QArr(K) * 1000)
SizeArr(K) = Sample
Next K

MaxVal = MaxValOfVoc(SizeArr())

If MaxVal > 0
ReFactor = 1000 / MaxVal
Else
ReFactor = 1
EndIf

For K = 0 To QArrSize
QArr(K) = QArr(K) * ReFactor
Next K

EndProcedure

Procedure Windower()
 Define Kw.l 
 Define NormGauss.d
 Define GaussCoeff1.d
 Define GaussCoeff2.d

For Kw = 0 To QArrSize
   GaussCoeff1 = (10 / (QArrSize - 1)) * (Kw - 1 *((QArrSize - 1) / 2))
   GaussCoeff2 = 1 / (Sqr(EnvelopeVal / 10) * Sqr(8 * ATan(1)))
   NormGauss = GaussCoeff2 * Exp(-1 * (Pow(GaussCoeff1, 2) / (2 *(EnvelopeVal / 10))))
   QArr(Kw) = NormGauss * QArr(Kw)
Next Kw

EndProcedure

Procedure CocktailSort1(Array pvarArray.i(1))
   Define I.l
   Define iMin.l
   Define iMax.l
   Define varSwap.l
   Define blnSwapped.l
   
   iMin = 0
   iMax = TheArrLen - 1
   Repeat
       blnSwapped = 0
       For I = iMin To iMax
           If pvarArray(I) > pvarArray(I + 1)
               varSwap = pvarArray(I)
               pvarArray(I) = pvarArray(I + 1)
               pvarArray(I + 1) = varSwap
               blnSwapped = 1
           EndIf
       Next
       iMax = iMax - 1
       If blnSwapped = 0 
         Break
       EndIf  
       For I = iMax To iMin Step -1
           If pvarArray(I) > pvarArray(I + 1)
               varSwap = pvarArray(I)
               pvarArray(I) = pvarArray(I + 1)
               pvarArray(I + 1) = varSwap
               blnSwapped = 1
           EndIf
       Next
       iMin = iMin + 1
   Until blnSwapped = 0
   
 EndProcedure  
 
 Procedure FillTheVoice(VocSnippetLength.l)

Define Tc.l
Define Naa.l
Define Nc.i
Dim ImpulseTrainArr.d(0)
Define PeriodofImpulse.l
;resonator 1 out
Dim OutputArr.d(0)
;resonator 1 coefficients
Define ACoeff.d
Define BCoeff.d
Define CCoeff.d
;resonator 2 out
Dim OutputArr2.d(0)
;resonator 2 coefficients
Define ACoeff2.d
Define BCoeff2.d
Define CCoeff2.d
;resonator 3 out
Dim OutputArr3.d(0) 
;resonator 3 coefficients
Define ACoeff3.d
Define BCoeff3.d
Define CCoeff3.d
;this one is To pass VocSnippetLength To SelectUtterance:
Define LengthOfVocSnippet.l

Dim VoicePitchArr.d(27)

LengthOfVocSnippet = VocSnippetLength

VoicePitchArr(0) = 61.73
VoicePitchArr(1) = 69.3
VoicePitchArr(2) = 77.78
VoicePitchArr(3) = 82.41
VoicePitchArr(4) = 92.5
VoicePitchArr(5) = 98
VoicePitchArr(6) = 103.8
VoicePitchArr(7) = 110
VoicePitchArr(8) = 123.5
VoicePitchArr(9) = 130.8
VoicePitchArr(10) = 146.8
VoicePitchArr(11) = 164.8
VoicePitchArr(12) = 174.6
VoicePitchArr(13) = 196
VoicePitchArr(14) = 220
VoicePitchArr(15) = 246.9
VoicePitchArr(16) = 261.6
VoicePitchArr(17) = 293.7
VoicePitchArr(18) = 329.6
VoicePitchArr(19) = 349.2
VoicePitchArr(20) = 392
VoicePitchArr(21) = 415.3
VoicePitchArr(22) = 440
VoicePitchArr(23) = 493.9
VoicePitchArr(24) = 523.3
VoicePitchArr(25) = 587.3
VoicePitchArr(26) = 659.3
VoicePitchArr(27) = 740

ReDim ImpulseTrainArr(VocSnippetLength)
ReDim OutputArr(VocSnippetLength)
ReDim OutputArr2(VocSnippetLength)
ReDim OutputArr3(VocSnippetLength)
ReDim QArr(VocSnippetLength)

QArrSize = VocSnippetLength ;this is where we set size of the segment for all other effects procedures

ReDim QArr(QArrSize)

;algorithm To choose a particular voice pitch based on position of frq sliders----------------------

   Define ubArr.i
   Define TheDiff.d
   Define TheMatchingIndex.i
   Define FromArrIndex.i
   Define ToArrIndex.i
   Define SelectIndexFromRange.i

   ubArr = 27 ;ubound of voicepitcharr

   For Nc = 0 To ubArr
       If Nc = 0
       TheMatchingIndex = 0
       TheDiff = Abs(LevelFrom - VoicePitchArr(Nc))
       Else
           If Abs(LevelFrom - VoicePitchArr(Nc)) < TheDiff
           TheDiff = Abs(LevelFrom - VoicePitchArr(Nc))
           TheMatchingIndex = Nc
           EndIf
        EndIf
   Next Nc

   FromArrIndex = TheMatchingIndex

    For Nc = 0 To ubArr
       If Nc = 0
       TheMatchingIndex = 0
       TheDiff = Abs(LevelTo - VoicePitchArr(Nc))
       Else
           If Abs(LevelTo - VoicePitchArr(Nc)) < TheDiff
           TheDiff = Abs(LevelTo - VoicePitchArr(Nc))
           TheMatchingIndex = Nc
           EndIf
        EndIf
   Next Nc
   ToArrIndex = TheMatchingIndex

   SelectIndexFromRange = Rand(FromArrIndex, ToArrIndex)
   
;end algorithm for selecting a voice pitch. below here, we will apply the result-------------------------------

;let us generate a sawtooth for the fundamental sound of the voice segment:

Define Phase.d
Define Phase_Add.d

Phase_Add = VoicePitchArr(SelectIndexFromRange) / SampleRate
Phase = 0

   For Tc = 0 To VocSnippetLength
       ImpulseTrainArr(Tc) = Sin(Pi2 * Saw(Phase))
       Phase = Phase + Phase_Add
       If Phase > 1
         Phase = Phase - 1
       EndIf  
   Next Tc

   SelectUtterance(VocSnippetLength)

;let us undertake filtering this now thru a resonator
   
   CCoeff = -1 * Exp(-2 * Pi * InitB1 / 44100)
   BCoeff = (2 * Exp(-1 * Pi * InitB1 / 44100)) * Cos(2 * Pi * InitF1 / 44100)
   ACoeff = 1 - CCoeff - BCoeff
   ;filter 2:
   CCoeff2 = -1 * Exp(-2 * Pi * InitB2 / 44100)
   BCoeff2 = (2 * Exp(-1 * Pi * InitB2 / 44100)) * Cos(2 * Pi * InitF2 / 44100)
   ACoeff2 = 1 - CCoeff2 - BCoeff2
   ;filter 3:
   CCoeff3 = -1 * Exp(-2 * Pi * InitB3 / 44100)
   BCoeff3 = (2 * Exp(-1 * Pi * InitB3 / 44100)) * Cos(2 * Pi * InitF3 / 44100)
   ACoeff3 = 1 - CCoeff3 - BCoeff3

   Tc = -1

   For Naa = 0 To VocSnippetLength
           If Naa <= TransitionPoint
               Tc = Tc + 1
               If Tc = 220
                   InitF1 = InitF1 + F1Increment
                   InitF2 = InitF2 + F2Increment
                   InitF3 = InitF3 + F3Increment
                   InitB1 = InitB1 + BW1Increment
                   InitB2 = InitB2 + BW2Increment
                   InitB3 = InitB3 + BW3Increment
                   CCoeff = -1 * Exp(-2 * Pi * InitB1 / 44100)
                   BCoeff = (2 * Exp(-1 * Pi * InitB1 / 44100)) * Cos(2 * Pi * InitF1 / 44100)
                   ACoeff = 1 - CCoeff - BCoeff
                   CCoeff2 = -1 * Exp(-2 * Pi * InitB2 / 44100)
                   BCoeff2 = (2 * Exp(-1 * Pi * InitB2 / 44100)) * Cos(2 * Pi * InitF2 / 44100)
                   ACoeff2 = 1 - CCoeff2 - BCoeff2
                   CCoeff3 = -1 * Exp(-2 * Pi * InitB3 / 44100)
                   BCoeff3 = (2 * Exp(-1 * Pi * InitB3 / 44100)) * Cos(2 * Pi * InitF3 / 44100)
                   ACoeff3 = 1 - CCoeff3 - BCoeff3
                   Tc = 0
              EndIf
           EndIf

               If Naa < 1
               OutputArr(Naa) = ACoeff * (0.5 * (((ImpulseTrainArr(Naa)))) * AmplitudeResonator1 / 100)
               OutputArr2(Naa) = ACoeff2 * (0.5 * (((ImpulseTrainArr(Naa)))) * AmplitudeResonator2 / 100)
               OutputArr3(Naa) = ACoeff3 * (0.5 * ((MoogFilter16(ImpulseTrainArr(Naa)))) * AmplitudeResonator3 / 100)
               ElseIf Naa < 2
               OutputArr(Naa) = ACoeff * (0.5 * (((ImpulseTrainArr(Naa)))) * AmplitudeResonator1 / 100) + BCoeff * OutputArr(Naa - 1)
               OutputArr2(Naa) = ACoeff2 * (0.5 * (((ImpulseTrainArr(Naa)))) * AmplitudeResonator2 / 100) + BCoeff2 * OutputArr2(Naa - 1)
               OutputArr3(Naa) = ACoeff3 * (0.5 * (((ImpulseTrainArr(Naa)))) * AmplitudeResonator3 / 100) + BCoeff3 * OutputArr3(Naa - 1)
               ElseIf Naa >= 2
               OutputArr(Naa) = ACoeff * (0.5 * (((ImpulseTrainArr(Naa)))) * AmplitudeResonator1 / 100) + BCoeff * OutputArr(Naa - 1) + CCoeff * OutputArr(Naa - 2)
               OutputArr2(Naa) = ACoeff2 * (0.5 * (((ImpulseTrainArr(Naa)))) * AmplitudeResonator2 / 100) + BCoeff2 * OutputArr2(Naa - 1) + CCoeff2 * OutputArr2(Naa - 2)
               OutputArr3(Naa) = ACoeff3 * (0.5 * (((ImpulseTrainArr(Naa)))) * AmplitudeResonator3 / 100) + BCoeff3 * OutputArr3(Naa - 1) + CCoeff3 * OutputArr3(Naa - 2)
               EndIf

       QArr(Naa) = (OutputArr(Naa) - OutputArr2(Naa) + OutputArr3(Naa)) / 3
     Next Naa
     
  ;now let us apply effects to this, and normalize and window the segment
     
If dowobble = 1
  If Rand(1,4) = 1
    Wobbler()
  EndIf  
EndIf  

If dochorus = 1
  If Rand(1,4) = 1
    Chorus16(Rand(5, chorusval), Rand(5, chorusval), Rand(5, chorusval) / 10, 100)
  EndIf  
EndIf

NormalizeVoc()

If DoCrazyDelay = 1
  If Rand(1,4) = 1
    CrazyDelay()
  EndIf  
EndIf

If dofilter = 1
  If Rand(1,3) = 1
    ApplyCrazyFilter()
  EndIf  
EndIf

Windower()

NormalizeVoc()

EndProcedure 
     
Procedure.d MoogFilter16(Uo.d)
  
  Define Q.d

   cutoffo = 500
   reso = 10 / 100

   Fo = 2 * cutoffo / SampleRate

   Po = Fo * (1.8 - 0.8 * Fo)
   Ko = Po + Po - 1
   t1o = (1 - Po) * 1.386249
   t2o = 12 + t1o * t1o
   ro = reso * (t2o + 6 * t1o) / (t2o - 6 * t1o)

   Xo = Uo - ro * y4o

   ;Four cascaded onepole filters (bilinear transform)
   Y1o = Xo * Po + oldxo * Po - Ko * Y1o
   y2o = Y1o * Po + oldy1o * Po - Ko * y2o
   y3o = y2o * Po + oldy2o * Po - Ko * y3o
   y4o = y3o * Po + oldy3o * Po - Ko * y4o

   ;Clipper band limited sigmoid
   y4o = y4o - (y4o * y4o * y4o) / 6

   oldxo = Xo
   oldy1o = Y1o
   oldy2o = y2o
   oldy3o = y3o

   Q = y4o
   
   ProcedureReturn Q

EndProcedure


Procedure SelectUtterance(VocSnipLen.l)
  
;we want To update every 5ms ie 220 samples
;the number of steps needed To morph F And BW is transitionpoint/220.
;In this number of steps F And BW have To go from initial To final

TransitionPoint = Int((Rand(20, 80) / 100) * VocSnipLen)
SelectTheVoice = Rand(1, 9)

If SelectTheVoice = 1
SelectTheVoice = 4
ElseIf SelectTheVoice = 2
SelectTheVoice = 10
ElseIf SelectTheVoice = 3
SelectTheVoice = 7
ElseIf SelectTheVoice = 4
SelectTheVoice = 3
ElseIf SelectTheVoice = 5
SelectTheVoice = 9
ElseIf SelectTheVoice = 6
SelectTheVoice = 2
ElseIf SelectTheVoice = 7
SelectTheVoice = 6
ElseIf SelectTheVoice = 8
SelectTheVoice = 8
ElseIf SelectTheVoice = 9
SelectTheVoice = 5
EndIf

If SelectTheVoice = 1
InitF1 = 310
InitF2 = 2020
InitF3 = 2960
InitB1 = 45
InitB2 = 200
InitB3 = 400
AmplitudeResonator1 = 100
AmplitudeResonator2 = 100
AmplitudeResonator3 = 100
F1Increment = 300 / (TransitionPoint / 220)
F2Increment = 50 / (TransitionPoint / 220)
F3Increment = 1000 / (TransitionPoint / 220)
BW1Increment = 15 / (TransitionPoint / 220)
BW2Increment = 0
BW3Increment = 100 / (TransitionPoint / 220)
EndIf

If SelectTheVoice = 2
InitF1 = 620
InitF2 = 1660
InitF3 = 2430
InitB1 = 70
InitB2 = 150
InitB3 = 320
AmplitudeResonator1 = 100
AmplitudeResonator2 = 100
AmplitudeResonator3 = 100
F1Increment = 30 / (TransitionPoint / 220)
F2Increment = 170 / (TransitionPoint / 220)
F3Increment = 40 / (TransitionPoint / 220)
BW1Increment = 0
BW2Increment = 0 / (TransitionPoint / 220)
BW3Increment = 0
EndIf

If SelectTheVoice = 3
InitF1 = 540
InitF2 = 1100
InitF3 = 2300
InitB1 = 80
InitB2 = 70
InitB3 = 70
AmplitudeResonator1 = 100
AmplitudeResonator2 = 100
AmplitudeResonator3 = 100
F1Increment = -90 / (TransitionPoint / 220)
F2Increment = -200 / (TransitionPoint / 220)
F3Increment = 0
BW1Increment = 0
BW2Increment = 0
BW3Increment = 0
EndIf

If SelectTheVoice = 4
InitF1 = 290
InitF2 = 2025
InitF3 = 2875
InitB1 = 63
InitB2 = 40
InitB3 = 145
AmplitudeResonator1 = 100
AmplitudeResonator2 = 100
AmplitudeResonator3 = 100
F1Increment = 0
F2Increment = 0
F3Increment = 0
BW1Increment = 0
BW2Increment = 0
BW3Increment = 0
EndIf

If SelectTheVoice = 5
InitF1 = 750
InitF2 = 1400
InitF3 = 2500
InitB1 = 130
InitB2 = 120
InitB3 = 80
AmplitudeResonator1 = 100
AmplitudeResonator2 = 100
AmplitudeResonator3 = 100
F1Increment = -300 / (TransitionPoint / 220)
F2Increment = -450 / (TransitionPoint / 220)
F3Increment = -200 / (TransitionPoint / 220)
BW1Increment = -30 / (TransitionPoint / 220)
BW2Increment = -20 / (TransitionPoint / 220)
BW3Increment = -10 / (TransitionPoint / 220)
EndIf

If SelectTheVoice = 6
InitF1 = 550
InitF2 = 750
InitF3 = 2500
InitB1 = 100
InitB2 = 100
InitB3 = 70
AmplitudeResonator1 = 100
AmplitudeResonator2 = 100
AmplitudeResonator3 = 100
F1Increment = -150 / (TransitionPoint / 220)
F2Increment = 1050 / (TransitionPoint / 220)
F3Increment = 0
BW1Increment = -50 / (TransitionPoint / 220)
BW2Increment = -10 / (TransitionPoint / 220)
BW3Increment = 30 / (TransitionPoint / 220)
EndIf

If SelectTheVoice = 7
InitF1 = 700
InitF2 = 900
InitF3 = 2500
InitB1 = 130
InitB2 = 120
InitB3 = 80
AmplitudeResonator1 = 100
AmplitudeResonator2 = 100
AmplitudeResonator3 = 100
F1Increment = -200 / (TransitionPoint / 220)
F2Increment = 400 / (TransitionPoint / 220)
F3Increment = -800 / (TransitionPoint / 220)
BW1Increment = -60 / (TransitionPoint / 220)
BW2Increment = -20 / (TransitionPoint / 220)
BW3Increment = 10 / (TransitionPoint / 220)
EndIf

If SelectTheVoice = 8
InitF1 = 300
InitF2 = 870
InitF3 = 2250
InitB1 = 100
InitB2 = 100
InitB3 = 100
AmplitudeResonator1 = 100
AmplitudeResonator2 = 100
AmplitudeResonator3 = 100
F1Increment = 0
F2Increment = 0
F3Increment = 0
BW1Increment = 0
BW2Increment = 0
BW3Increment = 0
EndIf

If SelectTheVoice = 9
InitF1 = 350
InitF2 = 1250
InitF3 = 2200
InitB1 = 65
InitB2 = 110
InitB3 = 140
AmplitudeResonator1 = 100
AmplitudeResonator2 = 86
AmplitudeResonator3 = 61
F1Increment = 500 / (TransitionPoint / 220)
F2Increment = 400 / (TransitionPoint / 220)
F3Increment = 800 / (TransitionPoint / 220)
BW1Increment = 0 / (TransitionPoint / 220)
BW2Increment = 0 / (TransitionPoint / 220)
BW3Increment = 0 / (TransitionPoint / 220)
EndIf

If SelectTheVoice = 10
InitF1 = 700
InitF2 = 1430
InitF3 = 2450
InitB1 = 37
InitB2 = 61
InitB3 = 89
AmplitudeResonator1 = 100
AmplitudeResonator2 = 100
AmplitudeResonator3 = 100
F1Increment = 0
F2Increment = 0
F3Increment = 0
BW1Increment = 0
BW2Increment = 0
BW3Increment = 0
EndIf

EndProcedure

Procedure WriteDoubleArrayToFile(Array DArr.d(1), Filename$)
    Result = #False
    File = CreateFile(#PB_Any, Filename$)
    If File
        If WriteData(File, @DArr(), (ArraySize(DArr())+1) * SizeOf(Double)) <> 0
            
            Result = #True
        EndIf
        CloseFile(File)
    EndIf
    ProcedureReturn Result 
  EndProcedure
  
  Procedure ReadDoubleArrayFromFile(Array DArr.d(1), Filename$) 
    Result = #False
    File = ReadFile(#PB_Any, Filename$)
    If File
        Size = Lof(File)
        ReDim DArr(Size / SizeOf(Double))
        GarbleSamples = Size / SizeOf(Double)
        If ReadData(File, @DArr(), Size)
            Result = #True
        EndIf
        CloseFile(File)
    EndIf
    ProcedureReturn Result
  EndProcedure
  
  Procedure ShowAboutWindow()
  
  Protected AboutWindow, myEditorGadget, CloseButton 
  Protected Text$
  Protected Quit
  
  AboutWindow = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 620, 373, "Garble Marvel Help", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
  If AboutWindow
    
    myEditorGadget = EditorGadget(#PB_Any, 5, 5, 610, 360, #PB_Editor_ReadOnly)
    
Text$ = Chr($d) + "*Press the 'speaking face' button to generate your garble" + Chr($d)
Text$ + Chr($d) + "*Your generated garble will repeat if you tick the Repeat checkbox and then press the 'speaking face' button" + Chr($d)
Text$ + Chr($d) + "*Select File>Save to save your garble sequence, and File>Open to load it back in"
Text$ + Chr($d) + "Note: Once you load a file, the Repeat checkbox will be auto-ticked. If you leave it ticked and then press"
Text$ + Chr($d) + "the 'speaking face' button, the loaded file will play, otherwise a new garble sequence will be generated"
Text$ + Chr($d) + "Also, please note that this file is not a standard audio file playable in a media player" + Chr($d)
Text$ + Chr($d) + "*Duration slider: adjusts the duration of garble from a fraction of a second to a few seconds" + Chr($d)
Text$ + Chr($d) + "*Frq From And Frq To sliders: sets the pitch range of the generated garble. All garble segments will be of a note pitch" 
Text$ + Chr($d) + "randomly selected from within this range" + Chr($d)
Text$ + Chr($d) + "*Num Of Sgmts: number of discrete voice segments in your garble sequence" + Chr($d)
Text$ + Chr($d) + "*Min Sgmt Length: the minimum length of any voice segment in your garble sequence"
Text$ + Chr($d) + "Note: Garble Marvel uses a 'brute force' technique to satisfy the specified number of segments and minimum segment"
Text$ + Chr($d) + "length in the sequence duration. If Garble Marvel is unable to create a sequence fitting the criteria after a few seconds" 
Text$ + Chr($d) + "of calculation, it will automatically adjust the Duration slider to a level allowing a sequence to be generated. You have" 
Text$ + Chr($d) + "a good chance of your criteria being met if you do not push both the minimum segment length and number of segments" 
Text$ + Chr($d) + "sliders to near maximum for long duration sequences" + Chr($d)
Text$ + Chr($d) + "*Env: adjusts the bell-shaped level envelope imposed on each voice segment. The shape will vary from 'squished'"
Text$ + Chr($d) + "to 'streteched out'. Useful for smoothing the transition between segments, or simply use as an effect" + Chr($d)
Text$ + Chr($d) + "*Effects on segments: If you tick an effect in this group, the effect will get randomly applied to segments in your sequence" + Chr($d)
Text$ + Chr($d) + "*Filter: randomly applies bandpass and low pass filters to segments" + Chr($d)
Text$ + Chr($d) + "*Metallic: randomly applies a multi-tap delay line with very short delay duration to segments" + Chr($d)
Text$ + Chr($d) + "*Chorus: randomly 'harmonizes' segments. The extent of harmonization can be adjusted with the slider. At extreme settings," 
Text$ + Chr($d) + "the chorus will transofrm to a 'warping effect' rather than a harmonization" + Chr($d)
Text$ + Chr($d) + "*Wobble: randomly applies tremolo to segments. The tremolo rate can be adjusted with the slider. At extreme settings," 
Text$ + Chr($d) + "the tremolo will sound more like a ring modulator effect" + Chr($d) 
    

    SetGadgetText(myEditorGadget, Text$)
    
    Repeat 
      
      Select WaitWindowEvent()
          
        Case #PB_Event_Gadget :      If EventGadget()=CloseButton : Break : EndIf
        Case #PB_Event_CloseWindow : If EventWindow()=AboutWindow : Break : EndIf 
          
      EndSelect
      
    ForEver
    
    CloseWindow(AboutWindow)
    
  EndIf
  
EndProcedure

Global Nm.l
Global Im.l
nm = 0
im = 0

RepeatPlay:

OnErrorGoto (?ErrorHandler)


Debug ArraySize(FinalGranularArr())
Debug GarbleSamples

PlayedAtLeastOnce = 1

err = Pa_Initialize()
If err <> #paNoError
  Error(err)
EndIf

  ProcedureC PaStreamCallback(*in, *output.Float, frameCount, *timeInfo.PaStreamCallbackTimeInfo, statusFlags, *userData)
  For Im = 1 To frameCount
  *output\f = FinalGranularArr(nm)
    *output+4
    nm + 1
    If nm >= ArraySize(FinalGranularArr())
      nm = 0 
    EndIf
  Next Im
EndProcedure

op.PaStreamParameters
op\channelCount = 1
op\device = Pa_GetDefaultOutputDevice()
op\sampleFormat = #paFloat32
op\suggestedLatency = 150/1000
err = Pa_OpenStream(@stream, 0, @op, SampleRate, 0, #paNoFlag, @PaStreamCallback(), 0)

If err <> #paNoError
  Error(err)
EndIf

Pa_StartStream(stream)
Pa_Sleep(GarbleDuration)
Pa_StopStream(stream)

Pa_Terminate()
Return

ErrorHandler:
Debug nm
End

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 300
; FirstLine = 297
; Folding = ----
; EnableXP
; Executable = gb2.exe
; DisableDebugger
; CompileSourceDirectory